diff -u tail.el.orig tail.el
--- tail.el.orig	2010-06-03 12:02:35.000000000 +1000
+++ tail.el	2010-06-05 08:43:42.000000000 +1000
@@ -84,6 +84,9 @@
 
 ;; Functions
 
+(defvar tail-timer nil)
+(make-variable-buffer-local 'tail-timer)
+
 ;; Taken from calendar/appt.el
 (defun tail-disp-window (tail-buffer tail-msg)
   "Display some content specified by TAIL-MSG inside buffer TAIL-BUFFER.
@@ -132,11 +135,15 @@
     (select-window this-window)
     (if tail-audible
 	(beep 1))
-    (if tail-hide-delay
-	(run-with-timer tail-hide-delay nil 'tail-hide-window tail-buffer))))
+    (when tail-hide-delay
+      (if tail-timer
+          (cancel-timer tail-timer))
+      (setq tail-timer (run-with-timer tail-hide-delay nil
+                                       'tail-hide-window tail-buffer)))))
 
 (defun tail-hide-window (buffer)
-  ;; TODO: cancel timer when some output comes during that time
+  (with-current-buffer buffer
+    (kill-local-variable 'tail-timer)) ;; the now expired timer object
   (let ((window (get-buffer-window buffer t)))
     (and window
 	 (or (eq window (frame-root-window (window-frame window)))
